Imports System
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Windows.Forms

Namespace nUsb

	Class Device

		''' <summary>
		''' USB foCXłB
		''' </summary>
		''' <remarks>
		''' <see cref="GetDeviceDataList"/>̌ʂi[\̂łB
		''' </remarks>
        Public Structure Status
			''' <summary>
			''' foCX̂łBfoCXɂĂ͋̕ɂȂꍇ܂B
			''' </summary>
            Public FriendlyName As String
			''' <summary>
			''' foCX ID łB
			''' </summary>
            Public DeviceId As String
			''' <summary>
			''' n[hEFA ID łB
			''' </summary>
            Public HardwareId As String
			''' <summary>
			''' ẽfoCX ID łB
			''' </summary>
            Public ParentDeviceId As String
			''' <summary>
			''' ҖłB
			''' </summary>
            Public Manufacturer As String
			''' <summary>
			''' foCX̐łB
			''' </summary>
            Public Description As String
			''' <summary>
			''' NXłB
			''' </summary>
            Public ClassName As String
			''' <summary>
			''' T[rXłB
			''' </summary>
            Public ServiceName As String
			''' <summary>
			''' foCXɑΉhCu^[łB
			''' </summary>
            Public DriveLetter As String
			''' <summary>
			''' C[WXg̃CfbNXԍłB
			''' </summary>
            Public ImageIndex As Integer
			''' <summary>
			''' foCXnhłB
			''' <see cref="EjectDevice"/><see cref="CheckInsert"/>Ŏgp܂B
			''' </summary>
            Public DeviceHandle As IntPtr
            ''' <summary>
            ''' ỎۂłB
            ''' </summary>
            Public Removable As Boolean
        End Structure
        ''' <summary>
        ''' ɐ܂B
        ''' </summary>
        Public Const Success As Integer = 0
        ''' <summary>
        ''' USB foCX݂܂B
        ''' </summary>
        Public Const ErrorNoData As Integer = -1
        ''' <summary>
        ''' OɎs܂B
        ''' </summary>
        Public Const ErrorEject As Integer = -2
        ''' <summary>
        ''' p[^słB
        ''' </summary>
        Public Const ErrorParameter As Integer = -3
        Protected Const BufferSize As Integer = 256

		''' <summary>
		''' USB foCX̐łB
		''' </summary>
        Protected _usb_count As Integer
		''' <summary>
		''' USB foCXɑΉACRi[ĂC[WXgłB
		''' </summary>
        Protected _image_list As ImageList
		''' <summary>
		''' USB foCX̔złB
		''' </summary>
        Protected _usb_list As Status() = Nothing

        ''' <summary>
        ''' USB foCXɑΉACRi[ĂC[WXg擾܂B
        ''' </summary>
        ''' <returns>C[WXg</returns>
        Public Function GetImageList() As ImageList
            Return _image_list
        End Function

        ''' <summary>
        ''' USB foCX擾܂B
        ''' </summary>
        ''' <returns>USB foCX</returns>
        Public Function GetData() As Integer
            Dim no As Integer
            Dim count As Integer

            _usb_count = GetDeviceData(0)
            _usb_list = New Status(_usb_count - 1) {}
            For no = 0 To _usb_count - 1
                Dim name As StringBuilder = New StringBuilder(BufferSize)

                GetFriendlyName(no, name, BufferSize)
                _usb_list(no).FriendlyName = name.ToString()

                GetDeviceId(no, name, BufferSize)
                _usb_list(no).DeviceId = name.ToString()

                GetHardwareId(no, name, BufferSize)
                _usb_list(no).HardwareId = name.ToString()

                GetParentDeviceId(no, name, BufferSize)
                _usb_list(no).ParentDeviceId = name.ToString()

                GetManufacturerName(no, name, BufferSize)
                _usb_list(no).Manufacturer = name.ToString()

                GetDescription(no, name, BufferSize)
                _usb_list(no).Description = name.ToString()

                GetClassName(no, name, BufferSize)
                _usb_list(no).ClassName = name.ToString()

                GetServiceName(no, name, BufferSize)
                _usb_list(no).ServiceName = name.ToString()

                GetDriveLetter(no, name, BufferSize)
                _usb_list(no).DriveLetter = name.ToString()

                _usb_list(no).ImageIndex = GetImageListIndex(no)
                _usb_list(no).DeviceHandle = GetDeviceHandle(no)
                _usb_list(no).Removable = CheckRemovable(_usb_list(no).DeviceHandle)
            Next no
            Dim Handle As IntPtr = GetImageListHandle()
            count = GetImageCount(Handle)
            _image_list = New ImageList()
            _image_list.ColorDepth = ColorDepth.Depth32Bit
            For no = 0 To count - 1
                Dim icon As System.Drawing.Icon = System.Drawing.Icon.FromHandle(GetIcon(Handle, no, 0))
                _image_list.Images.Add(icon)
            Next no
            ReleaseDeviceData()
            Return _usb_count
        End Function

        ''' <summary>
        ''' USB foCX\̂̔zԂ܂B
        ''' </summary>
        ''' <returns>USB foCX\̔z</returns>
        Public Function GetStatusList() As Status()
            Return CType(_usb_list.Clone(), Status())
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetDeviceData")> _
        Protected Shared Function GetDeviceData(ByVal Reserved As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbReleaseDeviceData")> _
        Protected Shared Function ReleaseDeviceData() As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetFriendlyName", CharSet:=CharSet.Auto)> _
        Protected Shared Function GetFriendlyName(ByVal No As Integer, ByVal Name As StringBuilder, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetDeviceId", CharSet:=CharSet.Auto)> _
        Protected Shared Function GetDeviceId(ByVal No As Integer, ByVal Name As StringBuilder, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetHardwareId", CharSet:=CharSet.Auto)> _
        Protected Shared Function GetHardwareId(ByVal No As Integer, ByVal Name As StringBuilder, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetParentDeviceId", CharSet:=CharSet.Auto)> _
        Protected Shared Function GetParentDeviceId(ByVal No As Integer, ByVal Name As StringBuilder, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetManufacturerName", CharSet:=CharSet.Auto)> _
        Protected Shared Function GetManufacturerName(ByVal No As Integer, ByVal Name As StringBuilder, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetDescription", CharSet:=CharSet.Auto)> _
        Protected Shared Function GetDescription(ByVal No As Integer, ByVal Name As StringBuilder, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetClassName", CharSet:=CharSet.Auto)> _
        Protected Shared Function GetClassName(ByVal No As Integer, ByVal Name As StringBuilder, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetServiceName", CharSet:=CharSet.Auto)> _
        Protected Shared Function GetServiceName(ByVal No As Integer, ByVal Name As StringBuilder, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetDriveLetter", CharSet:=CharSet.Auto)> _
        Protected Shared Function GetDriveLetter(ByVal No As Integer, ByVal Name As StringBuilder, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetImageListIndex")> _
        Protected Shared Function GetImageListIndex(ByVal No As Integer) As Integer
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetDeviceHandle")> _
        Protected Shared Function GetDeviceHandle(ByVal No As Integer) As IntPtr
        End Function

        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbGetImageListHandle")> _
        Protected Shared Function GetImageListHandle() As IntPtr
        End Function

        ''' <summary>
        ''' USB foCXO邩ׂ܂B
        ''' </summary>
        ''' <param name="Handle">foCXnh</param>
        ''' <returns>true ŎO\</returns>
        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbCheckRemovableHandle")> _
        Public Shared Function CheckRemovable(ByVal Handle As IntPtr) As Boolean
        End Function

        ''' <summary>
        ''' USB foCXO܂B
        ''' </summary>
        ''' <param name="Handle">foCXnh</param>
        ''' <returns>0 ̏ꍇ</returns>
        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbEjectDeviceHandle")> _
        Public Shared Function EjectDevice(ByVal Handle As IntPtr) As Integer
        End Function

        ''' <summary>
        ''' USB foCX̐ڑԂ𒲂ׂ܂B
        ''' </summary>
        ''' <param name="Handle">foCXnh</param>
        ''' <returns>true ŐڑAfalse ŐڑĂȂ</returns>
        <DllImport("nUsbDevice.DLL", EntryPoint:="NUsbCheckInsertDeviceHandle")> _
        Public Shared Function CheckInsert(ByVal Handle As IntPtr) As Boolean
        End Function

        <DllImport("comctl32.dll", EntryPoint:="ImageList_GetImageCount")> _
        Protected Shared Function GetImageCount(ByVal Handle As IntPtr) As Integer
        End Function

        <DllImport("comctl32.dll", EntryPoint:="ImageList_GetIcon")> _
        Protected Shared Function GetIcon(ByVal Handle As IntPtr, ByVal No As Integer, ByVal Flag As Integer) As IntPtr
        End Function
    End Class
End Namespace
