unit nUsbDevice;

interface

const
  NUSB_SUCCESS = 0;
  NUSB_ERROR_NO_DATA = -1;
  NUSB_ERROR_EJECT = -2;
  NUSB_ERROR_PARAMETER = -3;

function NUsbGetVersion: Integer; export; stdcall; External 'nUsbDevice.DLL';
function NUsbGetDeviceData(Reserved: Integer): Integer; export; stdcall; External 'nUsbDevice.DLL';
function NUsbReleaseDeviceData: Integer; export; stdcall; External 'nUsbDevice.DLL';
function NUsbGetFriendlyName(No: Integer; Name: PChar; Size:Integer): Integer; export; stdcall; External 'nUsbDevice.DLL' name 'NUsbGetFriendlyNameA';
function NUsbGetClassName(No: Integer; Name: PChar; Size:Integer): Integer; export; stdcall; External 'nUsbDevice.DLL' name 'NUsbGetClassNameA';
function NUsbGetServiceName(No: Integer; Name: PChar; Size:Integer): Integer; export; stdcall; External 'nUsbDevice.DLL' name 'NUsbGetServiceNameA';
function NUsbGetDeviceId(No: Integer; Name: PChar; Size:Integer): Integer; export; stdcall; External 'nUsbDevice.DLL' name 'NUsbGetDeviceIdA';
function NUsbGetParentDeviceId(No: Integer; Name: PChar; Size:Integer): Integer; export; stdcall; External 'nUsbDevice.DLL' name 'NUsbGetParentDeviceIdA';
function NUsbGetHardwareId(No: Integer; Name: PChar; Size:Integer): Integer; export; stdcall; External 'nUsbDevice.DLL' name 'NUsbGetHardwareIdA';
function NUsbGetDriveLetter(No: Integer; Name: PChar; Size:Integer): Integer; export; stdcall; External 'nUsbDevice.DLL' name 'NUsbGetDriveLetterA';
function NUsbGetDescription(No: Integer; Name: PChar; Size:Integer): Integer; export; stdcall; External 'nUsbDevice.DLL' name 'NUsbGetDescriptionA';
function NUsbGetManufacturerName(No: Integer; Name: PChar; Size:Integer): Integer; export; stdcall; External 'nUsbDevice.DLL' name 'NUsbGetManufacturerNameA';
function NUsbGetImageListIndex(No: Integer): Integer; export; stdcall; External 'nUsbDevice.DLL';
function NUsbGetImageListHandle: Integer; export; stdcall; External 'nUsbDevice.DLL';
function NUsbGetDeviceHandle(No: Integer): Integer; export; stdcall; External 'nUsbDevice.DLL';
function NUsbEjectDeviceHandle(Di: Integer): Integer; export; stdcall; External 'nUsbDevice.DLL';
function NUsbEjectDeviceNo(No: Integer): Integer; export; stdcall; External 'nUsbDevice.DLL';
function NUsbCheckInsertDeviceHandle(Di: Integer): LongBool; export; stdcall; External 'nUsbDevice.DLL';
function NUsbCheckInsertDeviceNo(No: Integer): LongBool; export; stdcall; External 'nUsbDevice.DLL';
function NUsbCheckRemovableHandle(Di: Integer): LongBool; export; stdcall; External 'nUsbDevice.DLL';
function NUsbCheckRemovableNo(No: Integer): LongBool; export; stdcall; External 'nUsbDevice.DLL';
function NUsbDriveToNo(Drive: PChar): Integer; export; stdcall; External 'nUsbDevice.DLL';

implementation

end.
