Attribute VB_Name = "nUsbDevice"
Option Explicit

Public Const NUSB_SUCCESS = 0
Public Const NUSB_ERROR_NO_DATA = -1
Public Const NUSB_ERROR_EJECT = -2
Public Const NUSB_ERROR_PARAMETER = -3

Public Declare Function NUsbGetVersion Lib "nUsbDevice" () As Long
Public Declare Function NUsbGetDeviceData Lib "nUsbDevice" (ByVal Reserved As Long) As Long
Public Declare Function NUsbReleaseDeviceData Lib "nUsbDevice" () As Long
Public Declare Function NUsbGetFriendlyName Lib "nUsbDevice" Alias "NUsbGetFriendlyNameA" (ByVal no As Long, ByVal name As String, ByVal Size As Integer) As Long
Public Declare Function NUsbGetClassName Lib "nUsbDevice" Alias "NUsbGetClassNameA" (ByVal no As Long, ByVal name As String, ByVal Size As Integer) As Long
Public Declare Function NUsbGetServiceName Lib "nUsbDevice" Alias "NUsbGetServiceNameA" (ByVal no As Long, ByVal name As String, ByVal Size As Integer) As Long
Public Declare Function NUsbGetDeviceId Lib "nUsbDevice" Alias "NUsbGetDeviceIdA" (ByVal no As Long, ByVal name As String, ByVal Size As Integer) As Long
Public Declare Function NUsbGetParentDeviceId Lib "nUsbDevice" Alias "NUsbGetParentDeviceIdA" (ByVal no As Long, ByVal name As String, ByVal Size As Integer) As Long
Public Declare Function NUsbGetHardwareId Lib "nUsbDevice" Alias "NUsbGetHardwareIdA" (ByVal no As Long, ByVal name As String, ByVal Size As Integer) As Long
Public Declare Function NUsbGetDriveLetter Lib "nUsbDevice" Alias "NUsbGetDriveLetterA" (ByVal no As Long, ByVal name As String, ByVal Size As Integer) As Long
Public Declare Function NUsbGetDescription Lib "nUsbDevice" Alias "NUsbGetDescriptionA" (ByVal no As Long, ByVal name As String, ByVal Size As Integer) As Long
Public Declare Function NUsbGetManufacturerName Lib "nUsbDevice" Alias "NUsbGetManufacturerNameA" (ByVal no As Long, ByVal name As String, ByVal Size As Integer) As Long
Public Declare Function NUsbGetImageListIndex Lib "nUsbDevice" (ByVal no As Long) As Long
Public Declare Function NUsbGetImageListHandle Lib "nUsbDevice" () As Long
Public Declare Function NUsbGetDeviceHandle Lib "nUsbDevice" (ByVal no As Long) As Long
Public Declare Function NUsbEjectDeviceHandle Lib "nUsbDevice" (ByVal Di As Long) As Long
Public Declare Function NUsbEjectDeviceNo Lib "nUsbDevice" (ByVal no As Long) As Long
Public Declare Function NUsbCheckInsertDeviceHandle Lib "nUsbDevice" (ByVal Di As Long) As Long
Public Declare Function NUsbCheckInsertDeviceNo Lib "nUsbDevice" (ByVal no As Long) As Long
Public Declare Function NUsbCheckRemovableHandle Lib "nUsbDevice" (ByVal Di As Long) As Boolean
Public Declare Function NUsbCheckRemovableNo Lib "nUsbDevice" (ByVal no As Long) As Boolean
Public Declare Function NUsbDriveToNo Lib "nUsbDevice" Alias "NUsbDriveToNoA" (ByVal Drive As String) As Long

Public Function NUsbGetString(Src As String) As String
    If InStr(Src, Chr(0)) > 0 Then
        NUsbGetString = Left(Src, InStr(Src, Chr(0)) - 1)
    Else
        NUsbGetString = Src
    End If
End Function
